#include "RKNNManager.hpp"
#include <opencv2/opencv.hpp>
#include <sys/time.h>
#include <thread>
#include <iostream>

void thread_infer(int index,RKNNManager* manager,cv::Mat *input, cv::Mat *output, int number)
{
    struct timeval start_time, stop_time;
    gettimeofday(&start_time, NULL);

    for (int i = number; i > 0; i--)
    {
       manager->infer(index,*input, *output);
    }

    gettimeofday(&stop_time, NULL);
    printf("infer time: %.3f ms\n",
           (stop_time.tv_sec - start_time.tv_sec) * 1000.0 +
               (stop_time.tv_usec - start_time.tv_usec) / 1000.0 / 10);
}

int main()
{

    bool res = true;
    struct timeval start_time, stop_time;
    RKNNManager manager1,manager2,manager3,manager4,manager5,manager6;

    res = manager1.initialize("../rknn_yolov5_demo/model/RK3588/yolov5s-640-640.rknn");
    res = manager2.initialize("../rknn_yolov5_demo/model/RK3588/yolov5s-640-640.rknn");
    res = manager3.initialize("../rknn_yolov5_demo/model/RK3588/yolov5s-640-640.rknn");
    // res = manager4.initialize("../rknn_yolov5_demo/model/RK3588/yolov5s-640-640.rknn");
    // res = manager5.initialize("../rknn_yolov5_demo/model/RK3588/yolov5s-640-640.rknn");
    // res = manager6.initialize("../rknn_yolov5_demo/model/RK3588/yolov5s-640-640.rknn");

    if (!res)
    {
        printf("initialize failed\n");
        return -1;
    }

    cv::Mat InputImage, OutputImage;
    cv::Mat OutputImage2, OutputImage3, OutputImage4, OutputImage5, OutputImage6;
    InputImage = cv::imread("../20170.jpg");

    cv::Mat img;
    cv::cvtColor(InputImage, img, cv::COLOR_BGR2RGB);

    std::thread(thread_infer,0,&manager1, &img, &OutputImage, 1000).detach();
    std::thread(thread_infer,1,&manager2, &img, &OutputImage2, 1000).detach();
    std::thread(thread_infer,2,&manager3, &img, &OutputImage3, 1000).detach();
    // std::thread(thread_infer,3,&manager4, &img, &OutputImage4, 17).detach();
    // std::thread(thread_infer,4,&manager5, &img, &OutputImage5, 17).detach();
    // std::thread(thread_infer,5,&manager6, &img, &OutputImage6, 17).detach();
    //std::thread(thread_infer, &img, &OutputImage3, 30).detach();
    // std::thread(thread_infer, &InputImage, &OutputImage4).detach();
    // // std::thread(thread_infer, &InputImage, &OutputImage5).detach();
    // // std::thread(thread_infer, &InputImage, &OutputImage6).detach();

    char a;

    std::cin >> a;

    cv::cvtColor(OutputImage, OutputImage, cv::COLOR_RGB2BGR);
    cv::imwrite("output.jpg", OutputImage);

    return 0;
}